--- dpkg.old/scripts/dpkg-shlibdeps.pl	2007-08-27 23:23:48.000000000 +0100
+++ dpkg-1.14.5/scripts/dpkg-shlibdeps.pl	2007-08-28 00:02:16.000000000 +0100
@@ -75,6 +75,16 @@
 "), $progname, join("/",@depfields);
 }
 
+# detect cross-compilation
+my $result = `dpkg-architecture -qDEB_HOST_ARCH`;
+chomp($result);
+my $host_arch = $result;
+$result = `dpkg-architecture -qDEB_BUILD_ARCH`;
+chomp($result);
+my $target_arch = $result;
+my $use_cross = 0;
+$use_cross = 1 if ($host_arch ne $target_arch);
+
 my ($stdout, @exec, @execfield);
 foreach (@ARGV) {
     if (m/^-T/) {
@@ -134,8 +144,21 @@
     }
 }
 
-my @librarypaths = qw( /lib /usr/lib /lib32 /usr/lib32 /lib64 /usr/lib64
-		       /emul/ia32-linux/lib /emul/ia32-linux/usr/lib );
+my @librarypaths=();
+if ($use_cross)
+{
+    my $crossprefix = `dpkg-architecture -qDEB_HOST_GNU_TYPE`;
+    chomp($crossprefix);
+    @librarypaths = ( "${crossprefix}/lib", "/usr/${crossprefix}/lib",
+        "/${crossprefix}/lib32", "/usr/${crossprefix}/lib32",
+        "/${crossprefix}/lib64", "/usr/${crossprefix}/lib64",
+        "/emul/ia32-linux/lib", "/emul/ia32-linux/usr/lib" );
+}
+else
+{
+    @librarypaths = qw( /lib /usr/lib /lib32 /usr/lib32 /lib64 /usr/lib64
+                      /emul/ia32-linux/lib /emul/ia32-linux/usr/lib );
+}
 my %librarypaths = map { $_ => 'default' } @librarypaths;
 
 if ($ENV{LD_LIBRARY_PATH}) {
